<?php


namespace rnpdfimporter\core\Integration\Processors\Settings\Forms\Fields;


class ComposedFieldSettings extends FieldSettingsBase
{
    /** @var ComposedFieldItem[] */
    public $Items;

    /**
     * ComposedFieldSettings constructor.
     */
    public function __construct()
    {
        $this->Items=[];
    }

    /**
     * @param $item ComposedFieldItem
     */
    public function AddComposedFieldItem($item)
    {
        $this->Items[]=$item;
    }

    public function AddItem($id,$path,$label)
    {
        $this->Items[]=new ComposedFieldItem($id,$path,$label);

    }

    public function InitializeFromOptions($options)
    {
        $this->Items=[];
        foreach($options->Items as $currentItem)
        {
            $composedItem=new ComposedFieldItem();
            $composedItem->InitializeFromOptions($currentItem);
            $this->Items[]=$composedItem;
        }

        parent::InitializeFromOptions($options); // TODO: Change the autogenerated stub
    }


    public function GetType()
    {
        return 'Composed';
    }
}


